//*****************************************************************************
// Arquivo pic_intext.c - módulo de configuração e uso da int externa
// Desenvolvido por Márcio José Soares
//*****************************************************************************

//*****************************************************************************
// O Copyright deste programa está reservado para TESC Sistemas de Controle LTDA
// e seu conteúdo está protegido pela Lei de Direitos Autorais LEI Nº 9.610, de
// 19 de Fevereiro de 1998. É estritamente proibida a reprodução total ou
// parcial dos conteúdos aqui apresentados sem prévia autorização, por escrito,
// do autor.
//*****************************************************************************

//*****************************************************************************
// Declara funções externas ao módulo
//*****************************************************************************
//void init_vars(void);

//*****************************************************************************
// Funções do módulo
//*****************************************************************************

//*****************************************************************************
// Função init_int_ext -inicia interrupção externa
//
// Entradas - nenhuma
// Saidas   - nenhuma
//*****************************************************************************
void init_int_ext(void){

    //*****************************************
    // int externa
    INTEDG = 0;                  	// int externa analisa borda de descida
    INTF = 0;                    	// força flag a zero
    INTE = 1;                    	// habilita a interrupção no pino RB0
}

//*****************************************************************************
// Função trata_int_ext -trata interrupção externa
//
// Entradas - nenhuma
// Saidas   - nenhuma
//*****************************************************************************
void trata_int_ext(void){

   //CLRWDT();	                     //zera WDT

   conta++;                            //incrementa contagem

   if (conta == 60){                   //igual a 60?
      conta=0;                         //zera
      ++horario.segundos;              //incrementa segundos

      if (horario.segundos > 59){      //igual a 60?
         horario.segundos = 0;         //retorna ao valor inicial
         ++horario.minutos;            //incrementa minutos

         if (horario.minutos > 59){   //igual a 60?
            horario.minutos = 0;       //retorna ao valor inicial
            ++horario.horas;           //incrementa horas

            if (horario.horas > hora_final){   //igual a 24 ou 12?
               horario.horas = hora_inicial;      //retorna tudo ao valor inicial
               horario.minutos = 0;
               horario.segundos = 0;
            }
         }
      }
   }
   //CLRWDT();	                     //zera WDT
   INTF = 0;                           //força flag a zero para nova int
}



